unit mainISCd;

interface


function udfIntruder_Create : integer; cdecl; export;
function udfIntruder_Terminate : integer; cdecl; export;
function udfIntruder_Resume : integer; cdecl; export;
function udfIntruder_Suspend : integer; cdecl; export;

function udfIntruder_SetReabilitatnLevel
     (var aReabilitationLevel : double) : double; cdecl; export;

function udfIntruder_GetReabilitatnLevel : double; cdecl; export;

function udfIntruder_SetBadLevel (var aBadLevel : double) : double; cdecl; export;
function udfIntruder_GetBadLevel : double; cdecl; export;

function udfIntruder_GetCurrentState : smallint; cdecl; export;


function udfIntruder_SetMeasuringPeriod
   (var aMeasuringPeriod : integer) : integer; cdecl; export;
function udfIntruder_GetMeasuringPeriod : integer; cdecl; export;

function udfIntruder_SetReabilitatPeriod
   (var aReabilitationPeriod : integer) : integer; cdecl; export;
function udfIntruder_GetReabilitatPeriod : integer; cdecl; export;

function udfIntruder_SetPoorPeriod (var aPoorPeriod : integer) : integer;
                                   cdecl; export;
function udfIntruder_GetPoorPeriod : integer; cdecl; export;

function udfIntruder_SetBadPeriod (var aBadPeriod : integer) : integer;
                                   cdecl; export;
function udfIntruder_GetBadPeriod : integer; cdecl; export;

function udfIntruder_SetRoughPeriod (var aRoughPeriod : integer) : integer;
                                   cdecl; export;
function udfIntruder_GetRoughPeriod : integer; cdecl; export;

function udfIntruder_SetRoughMode (var aRoughMode : smallint) : smallint;
                                   cdecl; export;

function udfIntruder_GetRoughMode : smallint;
                                   cdecl; export;


function udfIntruder_GetPoorPeriodCount : integer; cdecl; export;
function udfIntruder_GetBadPeriodCount : integer; cdecl; export;
function udfIntruder_GetRoughPeriodCount : integer; cdecl; export;
function udfIntruder_GetAverageCPUusage : double; cdecl; export;
function udfIntruder_GetAverageCPUusageM : double; cdecl; export;

implementation
 uses Windows, IntrThread, Classes;

{thread}var
{  MainThread  : THandle;}
  IntruderThread : TIntruderThread;

function udfIntruder_Create : integer; cdecl; export;
begin
 try
  IntruderThread := TIntruderThread.Create (True);
  IntruderThread.Priority := tpHigher;
  Result := integer(IntruderThread.MainThreadID);
 except
   Result := -11111;
 end;
end;

function udfIntruder_Terminate : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
    IntruderThread.Terminate;
 except
   Result := -11111;
 end;
 IntruderThread := nil;
end;

function udfIntruder_Resume : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
    IntruderThread.Resume;
 except
   Result := -11111;
 end;
end;

function udfIntruder_Suspend : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
    IntruderThread.Suspend;
 except
   Result := -11111;
 end;
end;


function udfIntruder_SetReabilitatnLevel
     (var aReabilitationLevel : double) : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.ReabilitationLevel := aReabilitationLevel;
     Result := IntruderThread.ReabilitationLevel;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
   Result := -11111;
 end;
end;


function udfIntruder_GetReabilitatnLevel : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.ReabilitationLevel;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
   Result := -11111;
 end;
end;


function udfIntruder_SetBadLevel (var aBadLevel : double) : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
      IntruderThread.BadLevel := aBadLevel;
      Result := IntruderThread.BadLevel;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
   Result := -11111;
 end;
end;

function udfIntruder_GetBadLevel : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.BadLevel;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
   Result := -11111;
 end;
end;


function udfIntruder_GetCurrentState : smallint; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := ord(IntruderThread.CurrentState);
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;



function udfIntruder_SetMeasuringPeriod
   (var aMeasuringPeriod : integer) : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.MeasuringPeriod := aMeasuringPeriod;
     Result := IntruderThread.MeasuringPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_GetMeasuringPeriod : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.MeasuringPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_SetReabilitatPeriod
   (var aReabilitationPeriod : integer) : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.ReabilitationPeriod := aReabilitationPeriod;
     Result := IntruderThread.ReabilitationPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_GetReabilitatPeriod : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.ReabilitationPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_SetPoorPeriod (var aPoorPeriod : integer) : integer;
                                   cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.PoorPeriod := aPoorPeriod;
     Result := IntruderThread.PoorPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetPoorPeriod : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.PoorPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_SetBadPeriod (var aBadPeriod : integer) : integer;
                                   cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.BadPeriod := aBadPeriod;
     Result := IntruderThread.BadPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetBadPeriod : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.BadPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_SetRoughPeriod (var aRoughPeriod : integer) : integer;
                                   cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.RoughPeriod := aRoughPeriod;
     Result := IntruderThread.RoughPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetRoughPeriod : integer; cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.RoughPeriod;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetPoorPeriodCount : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.PoorPeriodCount;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetBadPeriodCount : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.BadPeriodCount;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetRoughPeriodCount : integer; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.RoughPeriodCount;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetAverageCPUusage : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.AverageCPUusage;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_GetAverageCPUusageM : double; cdecl; export;
begin
 Result := 0;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := IntruderThread.AverageCPUusageMax;
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;

function udfIntruder_SetRoughMode (var aRoughMode : smallint) : smallint;
                                   cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     IntruderThread.AfterRoughMode := TAfterRoughMode(aRoughMode);
     Result := ord(IntruderThread.AfterRoughMode);
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;


function udfIntruder_GetRoughMode : smallint;
                                   cdecl; export;
begin
 Result := -11111;
 try
  if IntruderThread <> nil then
   begin
    IntruderThread.LockAccess;
    try
     Result := ord(IntruderThread.AfterRoughMode);
    finally
     IntruderThread.UnLockAccess;
    end;
   end;
 except
 end;
end;




exports
  udfIntruder_Create, udfIntruder_Terminate,
  udfIntruder_Resume, udfIntruder_Suspend,
  udfIntruder_SetReabilitatnLevel, udfIntruder_GetReabilitatnLevel,
  udfIntruder_SetBadLevel, udfIntruder_GetBadLevel,
  udfIntruder_GetCurrentState,
  udfIntruder_SetMeasuringPeriod, udfIntruder_GetMeasuringPeriod,
  udfIntruder_SetReabilitatPeriod, udfIntruder_GetReabilitatPeriod,
  udfIntruder_SetPoorPeriod,  udfIntruder_GetPoorPeriod,
  udfIntruder_SetBadPeriod, udfIntruder_GetBadPeriod,
  udfIntruder_SetRoughPeriod, udfIntruder_GetRoughPeriod,
  udfIntruder_SetRoughMode, udfIntruder_GetRoughMode,
  udfIntruder_GetPoorPeriodCount,
  udfIntruder_GetBadPeriodCount,
  udfIntruder_GetRoughPeriodCount,
  udfIntruder_GetAverageCPUusage,
  udfIntruder_GetAverageCPUusageM;

initialization
  IntruderThread := nil;

end.
